package com.ynet.life.exception;

import com.ynet.gene.core.GENEConstance;
import com.ynet.gene.web.servlet.view.ExceptionView;
import com.ynet.gene.web.servlet.view.JSPView;
import com.ynet.life.base.LifeErrorInfo;
import com.ynet.life.base.LifeStandard;
import com.ynet.life.base.Trace;
import java.util.Map;
import javax.servlet.RequestDispatcher;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

/* loaded from: com_ynet_life_exception.jar:com/ynet/life/exception/LifeExceptionView.class */
public class LifeExceptionView extends ExceptionView {
    private static final String JSP_ERROR_DEFAULT = "error_default.jsp";
    private static final String JSP_ERROR_FATAL = "error_fatal.jsp";
    private String urlBase;

    public void render(Map model, HttpServletRequest request, HttpServletResponse response, String jspRootPath) {
        LifeErrorInfo errorInfo;
        String errorPage = null;
        Object obj = (Exception) model.get(GENEConstance.ATTR_EXCEPTION);
        if ((obj instanceof TranFailException) && (errorInfo = LifeStandard.getErrorInfo(((TranFailException) obj).getErrorCode())) != null) {
            String returnPage = errorInfo.getReturnPage();
            errorPage = returnPage;
            if (returnPage == null) {
                switch (errorInfo.getLevel()) {
                    case 1:
                        JSPView inputView = (JSPView) request.getAttribute("GENE_INPUTVIEW");
                        if (inputView != null) {
                            request.removeAttribute("GENE_INPUTVIEW");
                            request.setAttribute("GENE_INPUTERROR", errorInfo.getShowMsg());
                            errorPage = String.valueOf(jspRootPath) + inputView.getUrl();
                            break;
                        }
                        break;
                    case 2:
                    default:
                        errorPage = String.valueOf(this.urlBase) + JSP_ERROR_DEFAULT;
                        break;
                    case 3:
                        errorPage = String.valueOf(this.urlBase) + JSP_ERROR_FATAL;
                        break;
                }
            } else {
                errorPage = String.valueOf(this.urlBase) + errorPage;
            }
        }
        if (errorPage == null) {
            errorPage = String.valueOf(this.urlBase) + JSP_ERROR_DEFAULT;
        }
        setModelToRequest(model, request);
        RequestDispatcher dispatcher = request.getRequestDispatcher(errorPage);
        try {
            dispatcher.forward(request, response);
        } catch (Exception ex) {
            Trace.logError(GENEConstance.GENE_MVC, "重定向错误页面失败", ex);
        }
    }

    public void setUrlBase(String urlBase) {
        this.urlBase = urlBase;
    }
}
